/** Excepcions 
 * @author Carles Royan Salvatella
 * @version 1.0 - Data: 18/06/2003
 */

public class NotMemberClassException extends PSemanticException 
{

    public NotMemberClassException() {
	super("semantic error");
    }
    public NotMemberClassException(String variable,String filename,int linia)
	{
		super(variable);
		identif=variable;
		line=linia;
		fileName=filename;
		
		column=0;
    }	
    public String toString() {
	return antlr.FileLineFormatter.getFormatter().
	    getFormatString(fileName,line)+getMessage();
    }	

	/**
	 * Retorna el missatge d'error (sense informacio de columna/linia)
	 */
	public String getMessage ()
	{
		return "'" + identif + "' no es un membre de classe";
	}
}
