// $ANTLR 2.7.1: "cpc.g" -> "CpcLexer.java"$

import java.io.*;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.ListIterator;

public interface PseudocodiTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int ALGORISME = 4;
	int FALGORISME = 5;
	int CONST = 6;
	int FCONST = 7;
	int VAR = 8;
	int FVAR = 9;
	int TAULA = 10;
	int DE = 11;
	int ENTER = 12;
	int REAL = 13;
	int CARACTER = 14;
	int BOOLEA = 15;
	int CERT = 16;
	int FALS = 17;
	int DIV = 18;
	int MOD = 19;
	int CREAR = 20;
	int DESTRUIR = 21;
	int NULL = 22;
	int MENTRE = 23;
	int FER = 24;
	int FMENTRE = 25;
	int SI = 26;
	int LLAVORS = 27;
	int ALTRAMENT = 28;
	int FSI = 29;
	int PER = 30;
	int FINS = 31;
	int PAS = 32;
	int FPER = 33;
	int CAS = 34;
	int FCAS = 35;
	int ESCRIURE = 36;
	int ESCRIURELN = 37;
	int LLEGIR = 38;
	int FUNCIO = 39;
	int RETORNA = 40;
	int FFUNCIO = 41;
	int RES = 42;
	int CLASSE = 43;
	int FCLASSE = 44;
	int HERETA = 45;
	int JO = 46;
	int SUPER = 47;
	int INTERFICIE = 48;
	int FINTERFICIE = 49;
	int IMPLEMENTACIO = 50;
	int FIMPLEMENTACIO = 51;
	int CONSTRUCTOR = 52;
	int FCONSTRUCTOR = 53;
	int DESTRUCTOR = 54;
	int FDESTRUCTOR = 55;
	int ATRIBUTS = 56;
	int FATRIBUTS = 57;
	int ATRIBUTS_CLASSE = 58;
	int FATRIBUTS_CLASSE = 59;
	int METODES = 60;
	int FMETODES = 61;
	int METODES_CLASSE = 62;
	int FMETODES_CLASSE = 63;
	int METODE = 64;
	int FMETODE = 65;
	int METODE_CLASSE = 66;
	int FMETODE_CLASSE = 67;
	int OP_I = 68;
	int OP_O = 69;
	int OP_NO = 70;
	int NUMERO_ENTER = 71;
	int NUMERO_REAL = 72;
	int ELEMENTAL_TYPE = 73;
	int CLASS_TYPE = 74;
	int CLASS_DEF = 75;
	int ACCIO = 76;
	int PUBLIC = 77;
	int PRIVATE = 78;
	int MEMBRE_CLASSE = 79;
	int SUPER_CLASS = 80;
	int IDENTIFICADOR = 81;
	int NUMERO = 82;
	int EXPONENT = 83;
	int LITERAL_CARACTER = 84;
	int LITERAL_CADENA = 85;
	int PAREN_ESQ = 86;
	int PAREN_DRET = 87;
	int CORXET_ESQ = 88;
	int CORXET_DRET = 89;
	int COMA = 90;
	int PUNTCOMA = 91;
	int PUNT = 92;
	int DOSPUNTS = 93;
	int SALT_LINIA = 94;
	int OP_SUMA = 95;
	int OP_RESTA = 96;
	int OP_MULT = 97;
	int OP_DIV = 98;
	int OP_IGUAL = 99;
	int OP_DIFERENT = 100;
	int OP_MPETIT = 101;
	int OP_MPETIT_IGUAL = 102;
	int OP_MGRAN_IGUAL = 103;
	int OP_MGRAN = 104;
	int OP_ASSIGNACIO = 105;
	int OP_CAS = 106;
	int ESPAIS_BLANC = 107;
	int COMENTARI1 = 108;
	int COMENTARI2 = 109;
}
