/** Excepcions 
 * @author Carles Royan Salvatella
 * @version 1.0 - Data: 18/06/2003
 */

public class TypeInvalidException extends PSemanticException 
{
	private String reqType,foundType;
	
    public TypeInvalidException() {
	super("semantic error");
    }
    public TypeInvalidException(String reqType,String foundType,String filename,int linia)
	{
		super("");
		identif="";
		line=linia;
		fileName=filename;
		if ((reqType!="") && (foundType!=""))
		{
			this.reqType=reqType;
			this.foundType=foundType;
		}
		
		column=0;
    }
    public TypeInvalidException(String filename,int linia)
	{
		super("");
		identif="";
		line=linia;
		fileName=filename;
		
		column=0;
    }		
    public String toString() {
	return antlr.FileLineFormatter.getFormatter().
	    getFormatString(fileName,line)+getMessage();
    }	

	/**
	 * Retorna el missatge d'error (sense informacio de columna/linia)
	 */
	public String getMessage ()
	{
		String msg;
		
		if ((reqType!=null) && (foundType!=null))
			msg="tipus incompatibles. Es necessita '" + reqType + "' trobat '" + foundType + "'";
		else
			msg="tipus incompatibles";
			
		return msg;
	}
}
